
;================================================================================================================= 
;----------------------------------------------LCD_8BIT.INC------------------------------------------------------ 
;			LIBRERIA PARA EL MANEJO DEL LCD CON EL PIC16F628 Y DE IGUAL MANERA SE PUEDE MODIFICAR PARA 
;	UTILIZARLO CON EL PIC16F877A CON SOLO MODIFICAR LAS LAS LINEAS DE SALIDA DONDE INICIALMENTE EL PUERTO B ES 
;				UTILIZADO COMO SALIDA DE DATOS Y EL PUERTO A ES UTILIZADO COMO SALIDA DE CONTROL 
;================================================================================================================= 
 

 
	#DEFINE RS PORTA,3 ;PORTA0
	
	#DEFINE RW PORTA,4 ;PORTA1
	
	#DEFINE EN PORTA,5; EN=enable ; PORTA2
 
	#DEFINE PD PORTC ;Bus de datos 
 
 
LCD_INICIA 
;RUTINA QUE INICIA EL LCD Y PREPARA PUERTOS DEL PIC (PUEDEN SER MODIFICADOS POSTERIORMENTE) 
	;	BSF			STATUS,RP0		;CONFIGURO DEL PUERTO A LOS PINES PA0->RS,  PA1->RW 
	;	BCF			TRISC,5			;Y EL PIN PA2->E, Y EL PUERTO B COMO BUS DE DATOS 
	;	BCF			TRISC,6 
	;	BCF			TRISC,7 
	;	CLRF		TRISB 
		BCF			STATUS,RP0 
		BCF			RW				;EN CASO DE ESTAR CONECTADO LE INDICA QUE SE VA A ESCRIBIR EN LCD 
		BCF			RS				;ACTIVA EL MODO DE COMANDO PONIENDO RS=0 
		BCF			EN				;IMPIDE EL FUNCIONAMIENTO DEL LCD PONIENDO E=0 Y ESPERA 
		CALL		Retardo_20ms	;ESPERA A QUE SE ESTABILICE EL NIVEL DE TENSION DEL LCD 
		MOVLW		B'00111000'		;ENVIO DEL COMANDO FUNCTION SET (001MMNF00) M=1->8BITS  N=1->2LINEAS 
	;	MOVWF		PORTB			;Y F=0->CARACTERES DE 5X7 PUNTOS 
		MOVWF		PD	

		CALL		ESCRIBE_EN_LCD 
		CALL		Retardo_5ms 
		MOVLW		B'00111000'		;SE REPITE ESTE PROCESO UNA VEZ MAS (EN TOTAL SON 3 VECES)PERO CON 
;		MOVWF		PORTB			;DIFERENTES VALORES DE RETARDO 
		MOVWF		PD

		CALL		ESCRIBE_EN_LCD 
		CALL		Retardo_200micros 
		MOVLW		B'00111000'		;SE VUELVE A REPETIR (ULTIMA VEZ) CON RETARDO DIFERENTE 
;		MOVWF		PORTB 
		MOVWF		PD

		CALL		ESCRIBE_EN_LCD 
	;APARTIR DE AQUI COMIENZA EL ENVIO DE SECUENCIA DE COMANDOS PARA ESCRITURA EN EL LCD 
		MOVLW		B'00111000'		;ENVIO DEL COMANDO FUNCTION SET (001MMNF00) M=1->8BITS  N=1->2LINEAS 
;		MOVWF		PORTB			;Y F=0->CARACTERES DE 5X7 PUNTOS
		MOVWF		PD 

		CALL		ENVIA_COMANDO 
		CALL		LCD_OFF 
		CALL		LCD_BORRA 
		MOVLW		B'00001100' 
	;	MOVWF		PORTB 
		MOVWF		PD

		CALL		ENVIA_COMANDO 
		MOVLW		B'00000110'		;ENVIA EL COMANDO ENTRY MODE SET  (000001DS) D=1->INCREMENTO DE LA POSICION DE 
		;MOVWF		PORTB			;LA DDRAM Y S=0-> NO SE DESPLAZA AL ESCRIBIR UN NUEVO CARACTER EN EL LCD 
		MOVWF		PD

		CALL		ENVIA_COMANDO 
		RETURN 
 
;================================================================================================================================== 
	;------COMANDOS QUE PUEDEN EJECUTARSE EN CUALQUIER MOMENTO PARA SALTOS DE LINEA BORRADO DE PANTALLA, ETC.--------- 
LCD_BORRA 
		MOVLW		0X01			;ENCIENDE EL DISPLAY DEL LCD (DISPLAY ON) Y BORRA SU CONTENIDO 
		MOVWF		PD
;		MOVWF		PORTB 
		CALL		ENVIA_COMANDO 
		RETURN 
 
LCD_OFF 
		MOVLW		B'00001000'			;APAGA EL DISPLAY DEL LCD (DISPLAY OFF) 
	;   MOVWF		PORTB			 	
		MOVWF		PD	
	
		CALL		ENVIA_COMANDO 
		RETURN 
 
LCD_LINEA1 
		MOVLW		B'10000000'		;SE SITUA EN LA LINEA 1 DEL LCD 
		;MOVWF		PORTB			;DIRECCION 00H DE LA DDRAM 
		MOVWF		PD	
		CALL		ENVIA_COMANDO 
		RETURN 
 
LCD_LINEA2 
		MOVLW		B'11000000'		;SE SITUA EN LA LINEA 2 DEL LCD 
		;MOVWF		PORTB			;DIRECCION 40H DE LA DDRAM 
		MOVWF		PD	
		CALL		ENVIA_COMANDO 
		RETURN 
 
;===================================================================================================================================== 
	;-------SUBRUTINAS ENVIA_COMANDO Y ESCRIBE_EN_LCD Y ENVIA_CARACTER---------------------------------------------------- 
;AQUI PODEMOS SELECCIONAR SI QUEREMOS ENVIAR UN COMANDO PARA MODIFICAR UNA FUNCION DEL LCD O PODEMOS ENVIAR UN CARCATER O SIMBOLO  
;ASCII PREVIAMENTE GUARDADO EN EL PUERTO B ADEMAS DE UN PEQUEO PULSO PARA ESCRIBIR UN COMANDO ESPECIAL DE INICIO DEL LCD 
ESCRIBE_EN_LCD 
		BSF			EN			;PERMITE FUNCIONAMIENTO DEL LCD MEDIANTE UN PEQUEO PULSO Y TERMINA IMPIDIENDO EL FUNCIONAMIENTO 
		BCF			EN			;DEL LCD PARA FUTURAS MODIFICACIONES DEL PUERTO B  
		RETURN 
 
ENVIA_COMANDO 
		BCF			RS			;ACTIVA EL MODO COMANDO, PONIENDO RS=0 
		BCF			RW 
		GOTO		ENVIA_LCD 
ENVIA_CARACTER 
		BSF			RS			;ACTIVA EL MODO DATO, PONIENDO RS=1 Y LO QUE HAY EN PORTB LO VISUALIZA EN CODIGO ASCII 
		BCF			RW 
		;MOVWF		PORTB 
		MOVWF		PD	
		GOTO		ENVIA_LCD 
 
ENVIA_LCD 
		CALL		ESCRIBE_EN_LCD	;LO QUE HAY EN EL PUERTO B LO ESCRIBE COMO COMANDO EN EL LCD 
		BTFSS		RS			;DEBEMOS GARANTIZA UNA CORRECTA ESCRITURA DE COMANDO O CARACTER EN EL LCD DANDO RETARDOS YA QUE NO 
		CALL		Retardo_2ms		;ESTAMOS CHECANDO EL BUSSY FLAG CON 2 MS EN MODO COMANDO Y 50MICROS EN MODO CARACTER 
		CALL		Retardo_50micros 
		RETURN 
		 


