    list p=16f877a
#include <p16f877a.inc>
 __CONFIG 0xF39
CUENTA EQU 0x21	    ;  registro donde contaremos
RETARDO  EQU 0x22   ;  registro para el retardo
NUM1 EQU 0X23
NUM2 EQU 0X24
#DEFINE BANCO0 BCF STATUS, 5	;definimos el banco 0 como Banco0
#DEFINE BANCO1 BSF STATUS, 5	;definimos el banco 1 como Banco1
    ORG 0x00
    GOTO INICIO 
TABLA MOVWF PCL ; cargamos el valor del acumulador en el registro PCL. Cuando se ejecute esta instruccin el PIC
    ; saltar inmediatamente a la direccin de programa que le hayamos metido. En esta tabla almacenaremos los valores que hay que
    ;sacar por el puerto para que se muestren en el display los nmeros del 0 al 9.
DISP RETLW '0'; Para mostrar el 0   , Retlw es una funcin de retorno de una subrutina, pero vuelve con un valor literal en el registro W,
    ;osea es como Return pero al lado le escribes un valor entre 0 y 255 que ser el que tendr W cuando retorne, adems esta funcin no afecta el registro de status
    RETLW '1';
    RETLW '2';
    RETLW '3';
    RETLW '4';
    RETLW '5';
    RETLW '6'; 
    RETLW '7'; 
    RETLW '8'; 
    RETLW '9'; 
    ;-------------------------------
INICIO 
    BANCO1 ; pasamos al banco 1
    MOVLW b'00000110' ; configuramos las E/S digitales
    MOVWF ADCON1 ;El registro adcon1 sirve para configurar los terminales de la puerta a, como entradas analogicas, o como e/s digitales posee la dirreccion 9fh(baco1)
    BCF TRISA, 0 ; configuramos RA0 como SALIDA
    CLRF TRISB ; configuramos el PUERTOB como ENTRADA
    BANCO0 ; vol  vemos al banco 0
    CLRF CUENTA ; pone a cero la cuenta
MUESTRA 
    MOVLW DISP ; carga en el acumulador la direccin donde se encuentra el primer valor de la tabla
    ADDWF CUENTA, 0 ; le suma el valor de la cuenta para obtener
    ;la direccin del valor que nos interesa
    CALL SUMA1
    CALL TABLA ; llama a la subrutina TABLA que no(s)
    ; devolver el valor correspondiente de la
	; tabla en el acumulador.
    CALL PANTALLA
    BTFSS PORTB, 0 ; si PIN0 es 1 (si no se presiona el botn)
    ; salta a la siguiente instruccin.
    ;CALL SUMA1 ; llama a la subrutina SUMA1 (si se ha presionado el pulsador, RA0 es 0)
    GOTO MUESTRA ;=con1
    ;***********************
    ;SUMA1: subrutina que suma 1 al registro CUENTA. Solo
    ;cuenta pulsaciones entre 0 y 9 (dado que se
    ;trata de un Display de 7 segmentos). Despus
    ;espera a que se suelte el pulsador conectado a RA0.
	;***********************
SUMA1 
    INCF CUENTA, 1 ; incrementa el registro CUENTA. A
    ; continuacin se mira si el registro CUENTA
    ; ha llegado a 0AH, en tal caso, se pone a
    ; cero para comenzar de nuevo. ================================================
    MOVLW B'00001001'; Carga 9 en el acumulador
    SUBWF CUENTA, 0 ; le resta CUENTA al acumulador
    BTFSC STATUS, 2 ; mira si el resultado ha sido CERO(de serlo,
    ; CUENTA sera igual a 9) 
    ; a continuacin espera a que se suelte l    con1
    ; pulsador (previene los rebotes).
    CALL REBOTE ; llama a la subrutina que previene los   ,con 0
    ; rebotes
    CLRF CUENTA ; si cuenta fue 9, la pone a cero.
ESPERA 
    BTFSS PORTB, 0 ;=rebisa que si el boton esta en 1
    GOTO ESPERA ; espera a que se suelte el pulsador para ;con 0
	; regresar
    CALL REBOTE ; llama a la subrutina rebote de nuevo
    RETURN
    ;***********************
    ;REBOTE: subrutina que hace una pequea temporizacin  para prevenir los rebotes.
    ;***********************
REBOTE 
    MOVLW 0FFH ; carga 0FFH en el acumulador
    MOVWF RETARDO ; mueve el contenido del acumulador a retardo
    DECFSZ RETARDO, 1
REBO
	GOTO REBO ; no retorna hasta que RETARDO llega a cero
	RETURN

PANTALLA
	banksel	PORTA
	    clrf	PORTA

	    banksel	ADCON1
	    movlw	0x06
	    movwf	ADCON1			;pines del Puerto A digitales

	    banksel	TRISA
	    clrf	TRISA			;puerto A como salida

							    ;control de LCD en RA3, RA4 y RA5
	    banksel	TRISC
	    clrf	TRISC			;puertoC como salida (Bus de datos de la LCD)


	    call	LCD_INICIA 	
	    call	LCD_LINEA1 
	    call	LCD_BORRA
C1
	    call	LCD_INICIA 
	    call	LCD_BORRA
	    call	LCD_LINEA1    

	    call	ENVIA_CARACTER 
	    
	    movwf NUM2
	    call ENVIA_CARACTER

	    goto		C1


	;***configura interrupciones*****
CONF_INT
	    banksel	INTCON		;activa las interrupciones	
	    movlw	b'11011000'	;activa las interrupciones perifericas
	    movwf	INTCON		;activa interupcion externa en RB0 (bit 4)
						    ;desactiva inerrupciones de cambio de estado en el puertoB (bit 3)
						    ;limpia las banderas de las interrupciones

	    banksel	OPTION_REG
	    bsf		OPTION_REG, INTEDG	;configura el flanco ascendente para la interrupcion RB0 (bit6)
	    return

    ;*****************
BLINK
	    banksel	PORTA
	    bsf		PORTA,0
	    banksel	PORTA
	    call	Retardo_1s
	    bcf		PORTA,0	
	    call	Retardo_1s
	    return
    ;***interrupcion*********
CHANGE

	    bcf		INTCON,INTF	;baja las banderas de las interrupciones
	    bcf		INTCON,RBIF	
	    retfie


    include <RETARDOS.INC>
    include <LCD2.INC>
    END